%mo own color macros
\usepackage{color}
%red, green, blue, yellow, cyan, magenta, black, white
\newcommand{\blue}[1]{\textcolor{blue}{#1}}
\newcommand{\red}[1]{\textcolor{red}{#1}}
\newcommand{\green}[1]{\textcolor{green}{#1}}%forrestgreen


\newcommand{\Note}{\blue{\bf Note: }}
\newcommand{\merk}[1]{\blue{\bf #1}}
\newcommand{\set}[1]{\{#1\}}
\newcommand{\defeq}{\,\triang\usepackage{mathptmx}}
\newcommand{\Hoare}[3]{\red{\set{#1}}\; #2\; \red{\set{#3}}}


%\usepackage[scaled=.92]{helvet}

% ********************************
% *********    MACROS    *********
% ********************************
\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{creol}[2008/02/06 v0.1 Creol Programming Language Environment]

\RequirePackage{listings}

\lstdefinelanguage{Creol}{%
  keywords={as,assert,await,begin,by,class,const,contracts,datatype,do,%
    else,end,ensures,exception,exists,extern,forall,from,fun,if,implements,%
    in,inherits,interface,inv,is,new,of,op,out,posit,prove,release,requires,%
    skip,some,then,throw,throws,try,var,when,where,while,with},%
  morekeywords=[2]{caller,history,this},%
  morekeywords=[3]{false,true,nil,now,null},%
  sensitive=true,%
  comment=[l]//,%
  morecomment=[l]--,%
  morecomment=[s]{/*}{*/},%
  string=[b]",%
  literate={~}{$\neg$}1 {|-}{$\vdash$}1 {/=}{$\neq$}1 {&&}{$\land$}2
           {||}{$\lor$}2 {+}{{$+$}}2 {/}{{$/$}}2 {*}{{$*$}}2 {[]}{$\Box\;$}2
           {>}{{$>$}}1 {<}{{$<$}}1 {|}{{$\mid$}}1 {:}{{$:$}}1
           {->}{{$\rightarrow$}}2 {>=}{{$\geq$}}1 {<=}{{$\leq$}}1
           {|-}{{$\vdash$}}1 {-|}{{$\dashv$}}1 {|-|}{{$\vdash|$}}2
           {/=}{$\ne$}1 {=>}{{$\Rightarrow$}}2
           {-->}{{$\longrightarrow$}}2  {:=}{{$:=$}}3
}[keywords,comments,strings]

\lstnewenvironment{creol}{%
    \lstset{language=Creol,tabsize=2}%
    \csname lst@SetFirstLabel\endcsname}
  {\csname lst@SaveFirstLabel\endcsname}

\endinput

% \usepackage{courier}
% \usepackage{listings}
% \usepackage{tikz}
% \usepackage{cite}
% \usepackage{multirow}

% \def\myttsize{\fontsize{8}{9}}
% \newcommand{\codesize}{\myttsize}

% \newcommand{\rulename}[1]{\textsc{\scriptsize{(#1)}}}
% \newcommand{\rulespace}{\hspace{5mm}}
% \newcommand{\eval}[2]{[\![#1]\!]_{#2}}

% \lstdefinelanguage{Maude}{
%   keywords={sort,sorts,subsort,subsorts,var,vars,assoc,associative,ceq,cq,comm,commutative,config,configuration,ctor,constructor,ex,extending,id:,identity,identity:,idem,idempotent,inc,including,iter,iterated,owise,otherwise,poly,polymorphic,prec,precedence,pr,protecting,strat,strategy,op,ops,eq,label,to,is,mod,endm,fmod,endfm,rl,crl,view,endv,eof,load,in,include,if,then,else,fi,from,by, and, not},
%   sensitive=true,
%   morecomment=[l]{--},
%   morecomment=[l]{***},
%   morecomment=[s]{***(}{)},
%   morestring=[b]",
%   literate={+}{{$+$}}1 {/}{{$/$}}1 {*}{{$*$}}1 {=}{{${}={}$}}1
%            {>}{{$>$}}1 {<}{{$<$}}1 {|}{{$\mid$}}1 {:}{{$:$}}1
%            {->}{{$\rightarrow$}}2 {>=}{{$\geq$}}2 {<=}{{$\leq$}}2
%            {=>}{{$\longrightarrow$}}2 {--}{-{}-}2 {:=}{{$:=$}}2
%            {~>}{{$\leadsto$}}2 {==}{{${}={}$}}2
%            {|->}{{$\mapsto$}}3 {---}{-{}-{}-}3 {=/=}{{${}\ne{}$}}1
% }


% \lstnewenvironment{maude}{%
%     \lstset{language=Maude,columns=flexible,mathescape=true}%
%     \csname lst@SetFirstLabel\endcsname}
%   {\csname lst@SaveFirstLabel\endcsname}


% \lstdefinelanguage{creol}
%   {morekeywords={class,interface,with,extends,inherits,implements,await,if,then,else,while,until,return,get,throw,try,catch,match,for,break,continue,do,true,false,null,super,this,new,skip,release,retract,fi,borrow,owner,as,read,write,active,unique,immutable,safe,void,Int,Nat,Bool,String,List,Oid,abstract,var,op,init,run,link,unlink,connect,disconnect,wless,loose,tight,begin,end,receive,send,some,in,out,all,od},
%    sensitive=false,
%    morestring=[b]",
%    morestring=[b]',
%    morecomment=[l]{//},
%    morecomment=[s]{/*}{*/)},
%    moredelim=[is][\textit]{__}{__},
%    moredelim=[is][\textbf]{_*}{*_},
%    literate={|-}{{$\!\!\!\vdash\!$}}1 {/=}{$\!\neq{}$}1 {&&}{$\!\!\!\land\;$}1
%             {||}{$\!\!\!\lor{}$}1
%    }[keywords,comments,strings]

% \lstnewenvironment{creol}
%   {\lstset{language=creol,basicstyle=\codesize\tt,tabsize=2,columns=fullflexible,captionpos=b,xleftmargin=2ex,keywordstyle=\bfseries,commentstyle=\sl\ttfamily,mathescape=true}}
%   {}

% \newcommand{\typerule}[2]{
%   \begin{array}{c}
%     #1 \\
%     \hline
%     #2
%   \end{array}}

% \newcommand{\ntyperule}[3]{
%   \begin{array}{c}
%     \textsc{\scriptsize ({#1})} \\
%     #2 \\
%     \hline
%     #3
%   \end{array}}

% \newcommand{\nredrule}[2]{
%   \begin{array}{c}
%     \textsc{\scriptsize ({#1})} \\
%     #2
%   \end{array}}

% \newcommand{\redrule}[1]{
%   \begin{array}{c}
%     #1
%   \end{array}}

% \newcommand{\id}[1]{\textsl{#1}}
% \newcommand{\Rid}[1]{\Red{\textsl{#1}}}
% \newcommand{\code}[1]{\texttt{#1}}
 \newcommand{\key}[1]{\texttt{\textbf{#1}}}
 \newcommand{\Key}[1]{~\key{#1}~}
% \newcommand{\Empty}{\varepsilon}
% \newcommand{\labelsX}{\TYPE{Label}}
% \newcommand{\labels}{{\labelsX} }
% \newcommand{\creolX}{\mbox{Creol}}
% \newcommand{\Creol}{\mbox{\creolX} }
% \newcommand{\rew}{\mbox{$\;\longrightarrow\;$}}
% \newcommand{\TYPE}[1]{\textsf{#1}}
% \newcommand{\Init}{\textsl{init}}
% \newcommand{\Run}{\textsl{run}}
% \newcommand{\mtdcallX}{\TYPE{MtdCall}}
% \newcommand{\mtdcall}{{\mtdcallX} }
% \newcommand{\objectexprX}{\TYPE{ObjExpr}}
% \newcommand{\objectexpr}{{\objectexprX} }
% \newcommand{\comX}{\TYPE{Stm}}
% \newcommand{\com}{{\comX} }
% \newcommand{\exprX}{\TYPE{Expr}}
% \newcommand{\expr}{{\exprX} }
% \newcommand{\guardsX}{\TYPE{Guard}}
% \newcommand{\guards}{{\guardsX} }
% \newcommand{\boolexprX}{\TYPE{BoolExpr}}
% \newcommand{\boolexpr}{{\boolexprX} }
% \newcommand{\varX}{\TYPE{Var}}
% \newcommand{\var}{{\varX} }
% \renewcommand{\*}[1]{{\overline{#1}}}
% \newcommand{\many}[1]{{\overline{#1}}}
% \newcommand{\meta}[1]{\{#1\}}
% %\newcommand{\Mapsto}{\mbox{$\mapsto$}}
% \newcommand{\CFG}{U*}
% \newcommand{\conn}[3]{\mbox{[{#1}~{#2}~{#3}]}}
